/**
 *  Copyright 2012-2017 Gunnar Morling (http://www.gunnarmorling.de/)
 *  and/or other contributors as indicated by the @authors tag. See the
 *  copyright.txt file in the distribution for a full listing of all
 *  contributors.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/**
 * <p>
 * MapStruct is a code generator which simplifies the implementation of mappings between Java bean types by generating
 * mapping code at compile time, following a convention-over-configuration approach. The generated code uses plain
 * method invocations and thus is fast and type-safe.
 * </p>
 * <p>
 * This package contains several annotations which allow to configure how mapper interfaces are generated.
 * </p>
 *
 * @see <a href="http://mapstruct.org/">MapStruct reference documentation</a>
 */
package org.mapstruct;
